#include<bits/stdc++.h>
using namespace std;
int N,K,T,Q,X,A[100009];
int cnt[31];
int main(){
  //freopen("A11.txt","r",stdin);
  ios_base::sync_with_stdio(false);
  cin>>N;
  for(int i=1; i<=N; i++)cin>>A[i];
  for(int pos=0,mask=1; pos<=30; pos++,mask*=2)
    for(int i=1; i<=N; i++)
      if(A[i]&mask)cnt[pos]++;
  cin>>Q;
  while(Q--){
    cin>>T>>K;
    if(T==0){
      int sol=0;
      for(int pos=0,mask=1; pos<=30; pos++,mask*=2)if(cnt[pos]>=K)sol+=mask;
      cout<<sol<<"\n";
    }
    if(T==1){
      cin>>X;
      for(int pos=0,mask=1; pos<=30; pos++,mask*=2)if(A[K]&mask)cnt[pos]--;
      A[K]=X;
      for(int pos=0,mask=1; pos<=30; pos++,mask*=2)if(A[K]&mask)cnt[pos]++;
    }
  }
  return 0;
}